/*
 * 
 * 
 */

package	com.idca.fsim.core;

import com.idca.fsim.core.plugins.SearchSource;
import	com.idca.fsim.core.plugins.listeners.FsimContextListener;
import	com.idca.fsim.core.plugins.listeners.FsimContextEvent;

import	java.util.Hashtable;
import	java.util.Collection;
import	java.util.Iterator;

/**
 * Manages the different Fsim contexts
 * 
 * @author Willem Cazander
 * @version 1.0 20/07/2005
 */
public class FsimServer
{
	static private Hashtable contexts = new Hashtable(1);
	
	static public void addFsimContext(FsimContext fsimContext)
	{
		if(contexts.get(fsimContext.getName())!=null)
		{
			System.out.println("Can't add an FsimContext with an already loaded name: "+fsimContext.getName());
			return;
		}
		contexts.put(fsimContext.getName(),fsimContext);
		
		// send events
		System.out.println("sending events of "+fsimContext.getName());
		Iterator i = fsimContext.getListeners().iterator();
		while(i.hasNext())
		{
			Object object = i.next();
			System.out.println("Object == "+object);
			if(object instanceof FsimContextListener) 
			{
				FsimContextListener fcl = (FsimContextListener)object;
				fcl.contextInitialized(new FsimContextEvent(fsimContext));
			}
		}
	}
	
	static public FsimContext getFsimContext(String name) {
		if(name==null) {
			return null;
		}
		return (FsimContext)contexts.get(name);
	}
	
	static public Collection getFsimContexts() {
		return contexts.values();
	}
}
