/*
 * Created on jul 16, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package	com.idca.fsim.core;

import	com.idca.fsim.core.comparators.WordListComparator;
import	com.idca.fsim.core.comparators.WordComparator;
import	com.idca.fsim.models.*;

import	java.util.logging.Logger;

import	java.util.List;
import	java.util.HashSet;
import	java.util.Iterator;
import	java.util.ArrayList;
import	java.util.Collection;
import	java.util.Collections;

import javax.servlet.ServletException;

/**
 * Searches
 * 
 * @author Willem Cazander
 * @version 1.0 Jan 22, 2006
 */
public class Searcher
{
	private WordLists wl = null;
	private Logger logger = Logger.getLogger(Searcher.class.getName());
	private ArrayList searchSources = new ArrayList(3);
	
	public Searcher(WordLists wl)
	{
		this.wl=wl;
	}
	
	public Collection searchWords(String word,boolean inWord)
	{
		String[] keyWords = word.split(" "); 
		
		
		
		
		//List result = null;
		List last = new ArrayList(19);
		for(int i=0;i<keyWords.length;i++)
		{
			String text = keyWords[i];
			//System.out.println("Doing "+text);
			List words = wl.getWords(text,inWord,false,false);
			//System.out.println("Searcher Doing "+text+" got "+words.size());
			Iterator a = words.iterator();
			while(a.hasNext())
			{
			    Word w = (Word)a.next();
			    //System.out.println("word = "+w.text);
			}
		
			last.addAll(words);
		}
		logger.info("Searched for word: >> "+word+" << found "+last.size()+" results.");
	
		// sort on hist list size and Keywords
		WordComparator wc =new WordComparator();
		wc.setKeywords(keyWords);
		Collections.sort(last,wc);
		
	//	Collections.sort(last,new WordClickedComperator());
		return last;
	}
	
	public Collection searchHits(String text,boolean inWord)
	{
		Collection last = searchWords(text,inWord);
		
		ArrayList hists = new ArrayList(100);
		Iterator x = last.iterator();
		while(x.hasNext()) {
			Word word = (Word)x.next();
			hists.addAll(word.hits);
		}

		return hists;
	}
	
	public void setSearchSources(String searchSources)
	{
		addSearchSources(this.searchSources,searchSources);
	}
	
	public boolean hasSearchSource(String searchSource)
	{
		if(searchSources.contains(searchSource)) {
			return true;
		}
		return false;
	}
	
	private void addSearchSources(List list,String sources)
	{
		String[] pathsA=sources.split(";");
		for(int i=0;i<pathsA.length;i++)
		{
			String path = pathsA[i];
			list.add(path);
		}
	}
	
}
