/*
 * Created on jul 16, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package com.idca.fsim.core.comparators;

import	com.idca.fsim.models.*;
import	java.util.*;

/**
 * Compare 2 Words.
 * 
 * @author Willem Cazander
 * @version 1.0 
 */
public class WordComparator implements Comparator
{
    private String[] keyWords = null;
    
	/**
	 * 
	 */
	public int compare(Object object1,Object object2) throws ClassCastException
	{
		Word word1 = (Word)object1;
		Word word2 = (Word)object2;
		
		if(keyWords==null) {
		    return 0;
		}
	
		int w1b = 0;
		int w2b = 0;

		// check for keywords.
		for(int i=0;i<keyWords.length;i++)
		{
			String text = keyWords[i].toLowerCase();
			if(text.indexOf(word1.text.toLowerCase())!=-1) {
			    w1b++;
			}
			if(text.indexOf(word2.text.toLowerCase())!=-1) {
			    w2b++;
			}
		}	
		System.out.println("w1b=="+word1.text+" :"+w1b+" w2b=="+word2.text+":"+w2b);
		
		if(w1b>w2b)
		{
			return -1;
		}
		if(w1b<w2b)
		{
			return 1;
		}
		return 0;
	}

	public void setKeywords(String[] keyWords)
	{
	    this.keyWords=keyWords;
	}
}