/*
 * Created on jul 16, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package	com.idca.fsim.core.config;

import	com.idca.fsim.core.FsimContext;

import	com.mbuyu.foei.xml.XMLDebugTagHandler;
import	com.mbuyu.foei.xml.XMLHandler;

import	javax.xml.parsers.SAXParser;
import	javax.xml.parsers.SAXParserFactory;
import	javax.xml.parsers.ParserConfigurationException;
import	org.xml.sax.SAXException;
import	java.io.FileInputStream;
import	java.io.InputStream;
import	java.io.IOException;

/**
 * Parseres fsim config xml syntax from an source.
 * 
 * @author Willem Cazander
 * @version 1.0 16/07/2005
 */
public class ConfigParser
{
	
	/**
	 * Opens this file and parse it xml fsim config syntaxS
	 * @param fileName
	 * @throws ParserConfigurationException
	 * @throws SAXException
	 * @throws IOException
	 */
	static public FsimContext parse(String fileName) throws ParserConfigurationException,SAXException,IOException
	{
		return parse(new FileInputStream(fileName));
	}
	

	/**
	 * Parse this xml stream as an fsim config syntax.
	 * @param inputStream
	 * @throws ParserConfigurationException
	 * @throws SAXException
	 * @throws IOException
	 */
	static public FsimContext parse(InputStream inputStream) throws ParserConfigurationException,SAXException,IOException
	{
		FsimContext fc = new FsimContext();
		XMLHandler handler = new XMLHandler();
		handler.addXMLHandler(new XMLDebugTagHandler());
		handler.addXMLHandler(new FsimConfigTagHandler(fc));
		//handler.addXMLHandler(new BundleTagHandler(fc));
		handler.addXMLHandler(new JSPIncludePageTagHandler(fc));
		//handler.addXMLHandler(new DataBaseTagHandler(fc));
		handler.addXMLHandler(new SearchSourceTagHandler(fc));
		handler.addXMLHandler(new ListenerTagHandler(fc));

		SAXParserFactory factory = SAXParserFactory.newInstance();
		factory.setNamespaceAware(true);
		SAXParser saxParser = factory.newSAXParser();		       
		saxParser.parse(inputStream,handler);
		return fc;
	}
}
