/*
 * Created on jul 16, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package	com.idca.fsim.core.plugins;

import	com.idca.fsim.models.Hit;

import com.idca.fsim.core.WordLists;
import	com.idca.fsim.core.plugins.ResultCollector;
import	com.idca.fsim.core.plugins.ResultRenderer;
import	java.util.Collection;
import	java.util.HashMap;
import	java.util.Date;

/**
 * An Searchable Source
 * 
 * @author Willem Cazander
 * @version 1.0 
 */
public class DBSearchSource implements SearchSource
{
	/** */
	private String name = null;
	/** */
	private String dbName = null;
	/** */
	private String tableName = null;
	/** */
	private String idColumnName = null;
	/** */
	private String searchColumnName = null;
	/** */
	private HashMap hits = new HashMap(4000);
	/** */
	private ResultCollector resultCollector = null;
	/** */
	private ResultRenderer resultRenderer = null;
	/** */
	private Date lastIndexed = null;
	/** */
	private Hit lastIndexedHit = null;
	/** */
	private WordLists wordList = new WordLists();
	/** */
	private Indexer indexer = null;
	
	/**
	 * 
	 * @param name
	 */
	public void setName(String name)
	{
		this.name=name;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getName()
	{
		return name;
	}
	
	/**
	 * 
	 * @param dbName
	 */
	public void setDBName(String dbName)
	{
		this.dbName=dbName;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getDBName()
	{
		return dbName;
	}
	
	/**
	 * 
	 * @param tableName
	 */
	public void setTableName(String tableName)
	{
		this.tableName=tableName;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getTableName()
	{
		return tableName;
	}
	
	/**
	 * 
	 * @param idColumnName
	 */
	public void setIDColumnName(String idColumnName)
	{
		this.idColumnName=idColumnName;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getIDColumnName()
	{
		return idColumnName;
	}
	
	/**
	 * 
	 * @param searchColumnName
	 */
	public void setSearchColumnName(String searchColumnName)
	{
		this.searchColumnName=searchColumnName;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getSearchColumnName()
	{
		return searchColumnName;
	}
	
	/**
	 * 
	 * @param hit
	 */
	public void addHit(Hit hit)
	{
		synchronized(hits)
		{
			hits.put(new Long(hit.id),hit);
			lastIndexedHit = hit;
		}
	}
	
	/**
	 * 
	 * @return
	 */
	public Collection getHits()
	{
		return hits.values();
	}
	
	public Hit getHit(Long id)
	{
		return (Hit)hits.get(id);
	}
	
	public Hit getHit(long id)
	{
		return (Hit)hits.get(new Long(id));
	}
	
	/**
	 * for some reason jstl didn't do source.hits.size ???
	 * @return
	 */
	public int getHitsSize()
	{
		return hits.size();
	}
	
	/**
	 * 
	 * @param resultCollector
	 */
	public void setResultCollector(ResultCollector resultCollector)
	{
		this.resultCollector=resultCollector;
	}
	
	/**
	 * 
	 * @return
	 */
	public ResultCollector getResultCollector()
	{
		return resultCollector;
	}
	
	public void setResultRenderer(ResultRenderer resultRenderer)
	{
		this.resultRenderer=resultRenderer;
	}
	public ResultRenderer getResultRenderer()
	{
		return resultRenderer;
	}
	
	
	/**
	 * 
	 * @param lastIndexed
	 */
	public void setLastIndexed(Date lastIndexed)
	{
		this.lastIndexed=lastIndexed;
	}
	
	/**
	 * 
	 * @return
	 */
	public Date getLastIndexed()
	{
		return lastIndexed;
	}
	
	public Hit getLastIndexedHit()
	{
	    return lastIndexedHit;
	}
	public long getLastIndexedHitID()
	{
	    if(lastIndexedHit==null) {
	        return 0;
	    }
	    return lastIndexedHit.id;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public WordLists getWordLists()
	{
		return wordList;
	}
	
	/**
	 * 
	 * 
	 * @param indexer
	 */
	public void setIndexer(Indexer indexer)
	{
		this.indexer=indexer;
	}
	
	/**
	 * 
	 * 
	 * @return
	 */
	public Indexer getIndexer()
	{
		return indexer;
	}
}
