/*
 * 
 * 
 */

package	com.idca.fsim.searchers.files.collectors;

import	com.idca.fsim.core.FsimContext;
import	com.idca.fsim.core.plugins.AbstractResultCollector;
import	com.idca.fsim.models.Hit;
import	com.idca.fsim.models.ModelHitTuble;
import	com.idca.fsim.searchers.files.PathManager;
import	com.idca.fsim.searchers.files.FilesListener;
import	com.idca.fsim.searchers.files.models.File;

import	java.sql.Connection;
import	java.sql.ResultSet;
import	java.sql.SQLException;
import	java.sql.Statement;
import	java.util.List;
import	java.util.Iterator;

/**
 * Returns the File search results
 * 
 * @author Willem Cazander
 * @version 1.0 Jan 22, 2006
 */
public class FileResultCollector extends AbstractResultCollector
{	
	public List getResults(List hits,FsimContext fsimContext,List result)
	{
		PathManager pm = FilesListener.getPathManager();
	
		if(hits.size()==0) {
			return result;
		}
		
		
		String sql =	"SELECT file.path_id,file.id as file_id,file.name,file.size,host.hostname,spider.udate"+
						" FROM file"+
						" LEFT JOIN path ON file.path_id = path.id"+
						" LEFT JOIN host ON path.host_id = host.id"+
						" LEFT JOIN spider ON host.last_spider_id = spider.id"+
						" WHERE file.id in ("; //62,248,566,3907,4195,3726)";
		
		
		//System.out.print("Getting FileResults total="+hits.size());
		Iterator i = hits.iterator();
		while(i.hasNext())
		{
			Hit hit = (Hit)i.next();		
			sql+=hit.id;
			if(i.hasNext()) {
				sql+=",";
			} else {
				sql+=")";
			}
		}
		
		//TODO: what to do with deleted records... delete the hits ??
		// now we skip them.
		
		try
		{
			Connection connection = fsimContext.getConnectionByName("fsim_dba");
			Statement stmt = connection.createStatement();
			ResultSet rs = stmt.executeQuery(sql);
			int h = 0;
			while(rs.next())
			{
				File file = new File();
				file.setName(rs.getString("name"));
				file.setSize(rs.getInt("size"));
				file.setPath(pm.getPath(rs.getInt("path_id")));
				
				int id = rs.getInt("file_id");
				i = hits.iterator();
				while(i.hasNext())
				{
					Hit hit = (Hit)i.next();
					if(hit.id==id)
					{
						result.add(new ModelHitTuble(hit,file));
						break;
					}
				}
				
			}
			rs.close();
			stmt.close();
			connection.close();
		}
		catch (SQLException sx)
		{
			System.err.println("SQL error: "+sx.getMessage());
		}
		return result;
	}	
}
