/*
 * 
 * 
 */

package	com.idca.fsim.searchers.files.collectors;

import	com.idca.fsim.core.FsimContext;
import	com.idca.fsim.core.plugins.AbstractResultCollector;
import	com.idca.fsim.models.Hit;
import	com.idca.fsim.models.ModelHitTuble;

import	com.idca.fsim.searchers.files.PathManager;
import	com.idca.fsim.searchers.files.FilesListener;
import	com.idca.fsim.searchers.files.models.Host;

import	java.util.List;
import	java.util.Iterator;

/**
 * Returns the Host search results
 * 
 * @author Willem Cazander
 * @version 1.0 27/05/2005
 */
public class HostResultCollector extends AbstractResultCollector
{	
	public List getResults(List hits,FsimContext fsimContext,List result)
	{
		PathManager pm = FilesListener.getPathManager();
		if(hits.size()==0) {
			return result;
		}
		
		Iterator i = hits.iterator();
		while(i.hasNext())
		{
			Hit hit = (Hit)i.next();
			Host host = pm.getHost(hit.id);
			result.add(new ModelHitTuble(hit,host));

		}
		return result;
	}
}
