/*
 * 
 */

package	com.idca.fsim.web;

import java.io.IOException;
import java.util.Date;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import	javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.idca.fsim.core.FsimContext;
import com.idca.fsim.core.FsimServer;
import com.idca.fsim.core.indexer.IndexRequest;
import com.idca.fsim.core.plugins.SearchSource;
import	com.idca.fsim.searchers.files.FilesListener;

/**
 * Proves the access for the admin pages.
 * 
 * @author Willem Cazander
 * @version 1.0 23/07/2005
 */
public class AdminServlet extends HttpServlet
{
	/** */
	private FsimContext fsimContext = null;
	/** */
	private String hostBlockedRedirectURL = null;
	/** */
	private int hostBlockedNoAdminPeneltyTime = 0;

	
	/**
	 * The service method of the servlet. <br>
	 *
	 * This method is called when a form has its tag value method equals to get.
	 * 
	 * @param request the request send by the client to the server
	 * @param response the response send by the server to the client
	 * @throws ServletException if an error occurred
	 * @throws IOException if an error occurred
	 */
	public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		try {
			
			HttpSession session = request.getSession();
			
			boolean isAdmin = false;
			Boolean admin = (Boolean)session.getAttribute("admin");
			if(admin!=null)
			{
				if(admin.booleanValue())
				{
					isAdmin = true;
				}
			}
			if(!isAdmin)
			{
				/*
				MonitoredHttpHost host = new MonitoredHttpHost();
				host.setHostAddress(request.getRemoteAddr());
				host.setMonitorStartDate(new Date());
				host.addRequest(RequestLoggerFilter.printNotificationURL(request));
				host.addMessage("Trying to get admin page while not being admin.");
				fsimContext.addMonitoredHTTPHost(host);
				host.addBlockedTime(hostBlockedNoAdminPeneltyTime*60*1000);
				SendBlockedRedirect.sendBlockedRedirect(response,host,hostBlockedRedirectURL);
				return;
				*/
				return;
			}
			
			
			String mode = request.getParameter("m");
			int m = 0;
			if(mode!=null)
			{
				try {
					m = new Integer(mode).intValue();
				} catch (Exception e) {
					m = 0;
				}
			}
			
			
			request.setAttribute("drawSearch",new Boolean(false));
			request.setAttribute("drawPageResults",new Boolean(false));
			
			RequestDispatcher top = request.getRequestDispatcher("fragments/fsim_top.jsp");
			top.include(request, response);		
			
			switch(m)
			{
				default:
			    case 0:			    	
			    	//request.setAttribute("sessions",fsimContext.getHttpSessions());
			    //	RequestDispatcher sessionsPage = request.getRequestDispatcher("fragments/fsim_sessions.jsp");
			    //	sessionsPage.include(request, response);
			    	break;
			    case 1:
			    	
			    	String hostAddress = request.getParameter("host_address");
			    	
			    	if(request.getParameter("host_add")!=null)
			    	{
			    		/*
			    		String reason = request.getParameter("host_reason");
						MonitoredHttpHost host = new MonitoredHttpHost();
						host.setHostAddress(hostAddress);
						host.setMonitorStartDate(new Date());
						host.addMessage("ADDED BY ADMIN: "+reason);
						host.addRequest("ADDED BY ADMIN");
						fsimContext.addMonitoredHTTPHost(host);
						*/
			    	}
			    	if(request.getParameter("host_monitoring_remove")!=null)
			    	{
			    		//fsimContext.removeMonitoring(hostAddress);
			    	}
			    	if(request.getParameter("host_permanent_add")!=null)
			    	{
			    		//MonitoredHttpHost host = fsimContext.getMonitoredHTTPHost(hostAddress);
			    	//	host.setPermenent(true);
			    	}
			    	if(request.getParameter("host_permanent_remove")!=null)
			    	{
			    	//	MonitoredHttpHost host = fsimContext.getMonitoredHTTPHost(hostAddress);
			    	//	host.setPermenent(false);
			    	}  			
			    	
			    	////request.setAttribute("httpHosts",fsimContext.getMonitoredHTTPHosts());
					//RequestDispatcher httpHostsPage = request.getRequestDispatcher("fragments/fsim_httphosts.jsp");
				///	httpHostsPage.include(request, response);
					break;
			    case 2:
			    	
			    	if(request.getParameter("source_index")!=null)
			    	{
			    		// do indeing
			    		SearchSource ss = fsimContext.getSearchSource(request.getParameter("source_name"));
			    		IndexRequest indexRequest = new IndexRequest(ss,fsimContext);
			    		indexRequest.execute();
			    	}
			    	if(request.getParameter("path_update")!=null)
			    	{
			    		FilesListener.getPathManager().updatePaths();
			    	}  
			    	if(request.getParameter("wordlists_info")!=null)
			    	{
			    		SearchSource ss = fsimContext.getSearchSource("fsim-files");
			    	    System.out.println(ss.getWordLists().dumpInfo());
			    	}
			    	
			    	request.setAttribute("sources",fsimContext.getSearchSources());
					RequestDispatcher sourcesPage = request.getRequestDispatcher("fragments/fsim_sources.jsp");
					sourcesPage.include(request, response);
					break;
			}

			RequestDispatcher bottom = request.getRequestDispatcher("fragments/fsim_bottom.jsp");
			bottom.include(request, response);
			
			
		} catch (Exception e) {
	    	RequestDispatcher sessionsPage = request.getRequestDispatcher("denied/real_error.jsp");
	    	sessionsPage.include(request, response);
		}
	}
	
	/**
	 * 
	 */
	public void init(ServletConfig servletConfig) throws ServletException
	{    
		fsimContext = FsimServer.getFsimContext(servletConfig.getServletContext().getInitParameter("FsimContextName"));
		if(fsimContext==null) {
			throw new ServletException("could not find fsimContextName: "+servletConfig.getServletContext().getInitParameter("FsimContextName"));
		}
		String hostBlockedNoAdminPeneltyTimeString = servletConfig.getInitParameter("hostBlockedNoAdminPeneltyTime");
		if(hostBlockedNoAdminPeneltyTimeString == null)
		{
			throw new ServletException("Could not find hostBlockedNoAdminPeneltyTime in ServletConfig.");
		}
		try {
			hostBlockedNoAdminPeneltyTime = new Integer(hostBlockedNoAdminPeneltyTimeString).intValue();
		} catch(Exception e) {
			throw new ServletException("hostBlockedNoAdminPeneltyTime is not an Integer");
		}
		
		hostBlockedRedirectURL = servletConfig.getServletContext().getInitParameter("hostBlockedRedirectURL");
		if(hostBlockedRedirectURL==null)
		{
			throw new ServletException("could not find hostBlockedRedirectURL in ServletContext.");
		}
	}
	
	
	public long getLastModified(HttpServletRequest request)
	{
		return System.currentTimeMillis();
	}	

	/**
	 * Returns information about the servlet, such as 
	 * author, version, and copyright. 
	 *
	 * @return String information about this servlet
	 */
	public String getServletInfo()
	{
		return "The FSIM admin servlet (c)2005 IDCA";
	}

	/**
	 * Destruction of the servlet. <br>
	 */
	public void destroy()
	{
		super.destroy();
	}
	
	
}
