/*
 * 
 */

package	com.idca.fsim.web;

import	com.idca.fsim.core.FsimContext;
import	com.idca.fsim.core.FsimServer;
import com.idca.fsim.core.plugins.ResultRenderer;
import com.idca.fsim.models.ModelHitTuble;
import	com.idca.fsim.models.Hit;

import	java.io.IOException;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Include an plugin page
 * 
 * @author Willem Cazander
 * @version 1.0 23/07/2005
 */
public class PluginPageServlet extends HttpServlet
{
	/** */
	private FsimContext fsimContext = null;
	/** */
	private String hostBlockedRedirectURL = null;
	/** */
	private int hostBlockedParameterPeneltyTime = 0;
		
	/**
	 * The service method of the servlet. <br>
	 *
	 * This method is called when a form has its tag value method equals to get.
	 * 
	 * @param request the request send by the client to the server
	 * @param response the response send by the server to the client
	 * @throws ServletException if an error occurred
	 * @throws IOException if an error occurred
	 */
	public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		try {
			
			String up = request.getParameter("up");
			if(up==null)
			{
				/*
				MonitoredHttpHost host = new MonitoredHttpHost();
				host.setHostAddress(request.getRemoteAddr());
				host.setMonitorStartDate(new Date());
				host.addMessage("Parameter 'up' not given.");
				fsimContext.addMonitoredHTTPHost(host);
				host.addBlockedTime(hostBlockedParameterPeneltyTime*60*1000);
				SendBlockedRedirect.sendBlockedRedirect(response,host,hostBlockedRedirectURL);
				*/
				return;
			}
			String page = fsimContext.getJSPIncludePage(up);
			if(page==null)
			{
				/*
				MonitoredHttpHost host = new MonitoredHttpHost();
				host.setHostAddress(request.getRemoteAddr());
				host.setMonitorStartDate(new Date());
				host.addMessage("page could not be found in specefied plugin pages.");
				fsimContext.addMonitoredHTTPHost(host);
				host.addBlockedTime(hostBlockedParameterPeneltyTime*60*1000);
				SendBlockedRedirect.sendBlockedRedirect(response,host,hostBlockedRedirectURL);
				*/
				return;
			}
			boolean drawFPD = true;
			if("false".equals(request.getParameter("fpd")))
			{
				drawFPD = false;
			}
			
			response.setHeader("Cache-Control", "no-cache");
			response.setContentType("text/html; charset=UTF-8");
			
			request.setAttribute("drawSearch",new Boolean(false));
			request.setAttribute("drawPageResults",new Boolean(false));
			
			System.out.println("hit:"+request.getSession().getAttribute("hit")+" model:"+request.getSession().getAttribute("model"));
			
			if(drawFPD)	
			{
				RequestDispatcher top = request.getRequestDispatcher("fragments/fsim_top.jsp");
				top.include(request, response);
			}

			RequestDispatcher ppage = request.getRequestDispatcher(page);
			ppage.include(request, response);
			
			if(drawFPD)
			{
				RequestDispatcher bottom = request.getRequestDispatcher("fragments/fsim_bottom.jsp");
				bottom.include(request, response);
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("WE HAVE EN ERROR IN PLUNGIN");
		}
	}
	
	/**
	 * 
	 */
	public void init(ServletConfig servletConfig) throws ServletException
	{    
		fsimContext = FsimServer.getFsimContext(servletConfig.getServletContext().getInitParameter("FsimContextName"));
		if(fsimContext==null) {
			throw new ServletException("could not find fsimContextName: "+servletConfig.getServletContext().getInitParameter("FsimContextName"));
		}
		String hostBlockedParameterPeneltyTimeString = servletConfig.getInitParameter("hostBlockedParameterPeneltyTime");
		if(hostBlockedParameterPeneltyTimeString == null)
		{
			throw new ServletException("Could not find hostBlockedParameterPeneltyTime in ServletConfig.");
		}
		try {
			hostBlockedParameterPeneltyTime = new Integer(hostBlockedParameterPeneltyTimeString).intValue();
		} catch(Exception e) {
			throw new ServletException("hostBlockedParameterPeneltyTime is not an Integer");
		}
		
		hostBlockedRedirectURL = servletConfig.getServletContext().getInitParameter("hostBlockedRedirectURL");
		if(hostBlockedRedirectURL==null)
		{
			throw new ServletException("could not find hostBlockedRedirectURL in ServletContext.");
		}
	}
	
	/**
	 * prevents caching
	 */
	public long getLastModified(HttpServletRequest request)
	{
		return System.currentTimeMillis();
	}	

	/**
	 * Returns information about the servlet, such as 
	 * author, version, and copyright. 
	 *
	 * @return String information about this servlet
	 */
	public String getServletInfo()
	{
		return "The FSIM plugin servlet (c)2005 IDCA";
	}	
}
