/*
 * 
 */

package	com.idca.fsim.web;

import	com.idca.fsim.core.FsimContext;
import	com.idca.fsim.core.FsimServer;
import com.idca.fsim.core.plugins.SearchSource;
import com.idca.fsim.models.Hit;
import com.idca.fsim.models.ModelHitTuble;

import java.util.Date;
import 	java.util.List;
import	java.util.ArrayList;
import	java.util.Iterator;

import	java.io.IOException;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import	javax.servlet.http.HttpSession;

/**
 * Redirect to other includes pages.
 * 
 * @author Willem Cazander
 * @version 1.0 23/07/2005
 */
public class RedirectServlet extends HttpServlet
{
	/** */
	private FsimContext fsimContext = null;
	/** */
	private String hostBlockedRedirectURL = null;
	/** */
	private int hostBlockedParameterPeneltyTime = 0;
	/** */
	private String pluginPageRedirectURL = null;
	
	/**
	 * The service method of the servlet. <br>
	 *
	 * This method is called when a form has its tag value method equals to get.
	 * 
	 * @param request the request send by the client to the server
	 * @param response the response send by the server to the client
	 * @throws ServletException if an error occurred
	 * @throws IOException if an error occurred
	 */
	public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		try {
			String ssString = request.getParameter("ss");
			if(ssString==null)
			{
				return;
			}
			SearchSource ss = fsimContext.getSearchSource(ssString);
			if(ss==null)
			{
				return;
			}

			Integer recordID = null;
			try {
				recordID = new Integer(request.getParameter("rid"));
			} catch(Exception e) {
				return;
			}
			
			Hit hit = ss.getHit(recordID);
			if(hit==null)
			{
				return;
			}
			// increase the value of this hit... !!!!
			hit.clicked++;
			
			String up = request.getParameter("up");
			if(up==null)
			{
				return;
			}
			List hits = new ArrayList();
			hits.add(hit);
			List tu = hit.source.getResultCollector().getResults(hits,fsimContext,new ArrayList(1));
			
			Iterator t = tu.iterator();
			if(!t.hasNext())
			{
				return;
			}
			ModelHitTuble modelHit = (ModelHitTuble)t.next();
			
			HttpSession session = request.getSession();
			session.setAttribute("hit",modelHit.getHit());
			session.setAttribute("model",modelHit.getModel());
			
			// door naar page	
			response.sendRedirect(pluginPageRedirectURL+"?up="+up+"&rid="+recordID+"&ss="+ss.getName()+"&fpd="+request.getParameter("fpd"));
			
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR IN REDIRECT SERVLET");
		}
	}
	
	/**
	 * 
	 */
	public void init(ServletConfig servletConfig) throws ServletException
	{    
		fsimContext = FsimServer.getFsimContext(servletConfig.getServletContext().getInitParameter("FsimContextName"));
		if(fsimContext==null) {
			throw new ServletException("could not find fsimContextName: "+servletConfig.getServletContext().getInitParameter("FsimContextName"));
		}
		
		String hostBlockedParameterPeneltyTimeString = servletConfig.getInitParameter("hostBlockedParameterPeneltyTime");
		if(hostBlockedParameterPeneltyTimeString == null)
		{
			throw new ServletException("Could not find hostBlockedParameterPeneltyTime in ServletConfig.");
		}
		try {
			hostBlockedParameterPeneltyTime = new Integer(hostBlockedParameterPeneltyTimeString).intValue();
		} catch(Exception e) {
			throw new ServletException("hostBlockedParameterPeneltyTime is not an Integer");
		}
		
		hostBlockedRedirectURL = servletConfig.getServletContext().getInitParameter("hostBlockedRedirectURL");
		if(hostBlockedRedirectURL==null)
		{
			throw new ServletException("could not find hostBlockedRedirectURL in ServletContext.");
		}
		
		pluginPageRedirectURL = servletConfig.getInitParameter("pluginPageRedirectURL");
		if(pluginPageRedirectURL==null)
		{
			throw new ServletException("coudl not find pluginPageRedirectURL in ServletContext");
		}
	}
	
	
	/**
	 * prevents caching
	 */
	public long getLastModified(HttpServletRequest request)
	{
		return System.currentTimeMillis();
	}	

	/**
	 * Returns information about the servlet, such as 
	 * author, version, and copyright. 
	 *
	 * @return String information about this servlet
	 */
	public String getServletInfo()
	{
		return "The FSIM redirect servlet (c)2005 IDCA";
	}
}
